/*************************************************************************
Title:    
Author:   
File:    
Software: 
Hardware: 
          
         
**************************************************************************/
#include <stdlib.h>
#include <avr/io.h>
#include <stdint.h>
#include <avr/interrupt.h> 
#include "lcd.h"




/*Funktionen*/ 


uint16_t ReadChannel(uint8_t mux)
{
  uint16_t result=0;
  ADMUX = mux;                                      // Kanal waehlen 
  ADMUX |= (1 << REFS0) | (1 << REFS1);            /*Interne 2.56V Refferenz ein Kanal 0 Auswhlen*/ 
  ADCSR |= (1<<ADEN) |(1 << ADPS1)| (1 << ADPS2); /*ADC aktivieren, Vorteiler 64 (Clock nicht mehr als 200khz) */
    
	
	
     
    ADCSR |= (1<<ADSC);              // eine Wandlung "single conversion"
    
	
	while ( ADCSR & (1<<ADSC) ) {    // auf Abschluss der Konvertierung warten
      
                                }    
  
    //ADCSR &= ~(1 << ADEN);
  return result;
}




void ItoA( int z, char* Buffer )
{
  int i = 0;
  int j;
  char tmp;
  

  unsigned u; // In u bearbeiten wir den Absolutbetrag von z.
  
    // ist die Zahl negativ?
    // gleich mal ein - hinterlassen und die Zahl positiv machen
    if( z < 0 ) {
      Buffer[0] = '-';
      Buffer++;
      // -INT_MIN ist idR. grer als INT_MAX und nicht mehr 
      // als int darstellbar! Man muss daher bei der Bildung 
      // des Absolutbetrages aufpassen.
      u=((unsigned)-(z+1))+1; 
    }
    else { 
      u=(unsigned)z;
    }
    // die einzelnen Stellen der Zahl berechnen
    do {
      Buffer[i++] = '0' + u % 10;
      u /= 10;
    } while(u>0);
     // den String in sich spiegeln
    for( j = 0; j < i / 2; ++j ) {
      tmp = Buffer[j];
      Buffer[j] = Buffer[i-j-1];
      Buffer[i-j-1] = tmp;
    }
    Buffer[i] = '\0';
    
}


 




int main(void)
{


/*Initialisierungen*/


//Ports 
DDRA  |= (1 << DDA3) | (1 << DDA4)| (1 << DDA5);              /*Port A Pin 3,5,4 als Ausgang*/
PORTA |= (1 << PA3)  | (1 << PA4)|(1 << PA6) |(1 << PA7);     /*Ausgnge und Pullups schalten */ 

DDRB = 0b00000000;                                            /*Port B Alles Ausgnge */
PORTB= 0b00000000;                                            /*Ausgnge auf 0 */

/*AnalogComperator*/
ACSR |= (1 << ACIE) | (1 << ACIS1);                          /*AC Interrupt Enable Intr. bei Fallender Flanke */



/*LCD*/
lcd_init(LCD_DISP_ON);                                      //Display mit Starttext initialisieren
lcd_clrscr();
lcd_puts("Absorber=");
lcd_gotoxy(12,0);
lcd_puts("C");
lcd_gotoxy(0,1);
lcd_puts("Speicher=");    	
lcd_gotoxy(12,1);
lcd_puts("C");

//sei();
      
// Hauptschleife 
   
   while(1)                
   { 
   char Buffer[10];
   uint16_t ADCWERT;

   ADCWERT=ReadChannel(0);
   ItoA(ADCWERT,Buffer);
   lcd_gotoxy(9,0);
   lcd_puts(Buffer);
   
   ADCWERT=ReadChannel(1);
   ItoA(ADCWERT,Buffer);
   lcd_gotoxy(9,1);
   lcd_puts(Buffer);
   }
   
   
                                    

  return 0;                
}
               
